#
# Copyright (c) 2002, Art Haas
#
#
# test circles
#

import unittest
import random
import math

import Generic.point as point
import Generic.circle as circle

def absdiff(testval, goodval):
    return abs(testval - goodval)

class CircleTestCase(unittest.TestCase):
    def setUp(self):
        self.p1 = point.Point(0,0)
        self.p2 = point.Point(10,0)
        self.p3 = point.Point(0,10)
        self.p4 = point.Point(-10,0)
        self.p5 = point.Point(0,-10)
        self.c1 = circle.Circle(self.p1, 5)
        self.c2 = circle.Circle(self.p2, 5)
        self.c3 = circle.Circle(self.p3, 5)
        self.c4 = circle.Circle(self.p4, 5)
        self.c5 = circle.Circle(self.p5, 5)
        self.c6 = circle.Circle(self.p1, 10)
        self.c7 = circle.Circle(self.p2, 10)
        self.c8 = circle.Circle(self.p3, 10)
        self.c9 = circle.Circle(self.p4, 10)
        self.c10 = circle.Circle(self.p5, 10)

    def testCreation(self):
        self.failUnless(self.c1.center is self.p1 and self.c1.radius == 5)
        self.failUnless(self.c2.center is self.p2 and self.c2.radius == 5)
        self.failUnless(self.c3.center is self.p3 and self.c2.radius == 5)
        self.failUnless(self.c4.center is self.p4 and self.c4.radius == 5)
        self.failUnless(self.c5.center is self.p5 and self.c5.radius == 5)
        self.failUnless(self.c6.center is self.p1 and self.c6.radius == 10)
        self.failUnless(self.c7.center is self.p2 and self.c7.radius == 10)
        self.failUnless(self.c8.center is self.p3 and self.c8.radius == 10)
        self.failUnless(self.c9.center is self.p4 and self.c9.radius == 10)
        self.failUnless(self.c10.center is self.p5 and self.c10.radius == 10)

    def testComparison(self):
        self.failUnless(self.c1 == self.c1)
        self.failUnless(self.c1 < self.c2 and self.c2 > self.c1)
        self.failUnless(self.c1 < self.c3 and self.c3 > self.c1)
        self.failUnless(self.c1 > self.c4 and self.c4 < self.c1)
        self.failUnless(self.c1 > self.c5 and self.c5 < self.c1)
        self.failUnless(self.c1 > self.c6 and self.c6 < self.c1)
        self.failUnless(self.c1 < self.c7 and self.c7 > self.c1)
        self.failUnless(self.c1 > self.c8 and self.c8 < self.c1)
        self.failUnless(self.c1 > self.c9 and self.c9 < self.c1)
        self.failUnless(self.c1 > self.c10 and self.c10 < self.c1)

        self.failUnless(self.c2 == self.c2)
        self.failUnless(self.c2 > self.c3 and self.c3 < self.c2)
        self.failUnless(self.c2 > self.c4 and self.c4 < self.c2)
        self.failUnless(self.c2 > self.c5 and self.c5 < self.c2)
        self.failUnless(self.c2 > self.c6 and self.c6 < self.c2)
        self.failUnless(self.c2 > self.c7 and self.c7 < self.c2)
        self.failUnless(self.c2 > self.c8 and self.c8 < self.c2)
        self.failUnless(self.c2 > self.c9 and self.c9 < self.c2)
        self.failUnless(self.c2 > self.c10 and self.c10 < self.c2)

        self.failUnless(self.c3 == self.c3)
        self.failUnless(self.c3 > self.c4 and self.c4 < self.c3)
        self.failUnless(self.c3 > self.c5 and self.c5 < self.c3)
        self.failUnless(self.c3 > self.c6 and self.c6 < self.c3)
        self.failUnless(self.c3 < self.c7 and self.c7 > self.c3)
        self.failUnless(self.c3 > self.c8 and self.c8 < self.c3)
        self.failUnless(self.c3 > self.c9 and self.c9 < self.c3)
        self.failUnless(self.c3 > self.c10 and self.c10 < self.c3)

        self.failUnless(self.c4 == self.c4)
        self.failUnless(self.c4 < self.c5 and self.c5 > self.c4)
        self.failUnless(self.c4 < self.c6 and self.c6 > self.c4)
        self.failUnless(self.c4 < self.c7 and self.c7 > self.c4)
        self.failUnless(self.c4 < self.c8 and self.c8 > self.c4)
        self.failUnless(self.c4 > self.c9 and self.c9 < self.c4)
        self.failUnless(self.c4 < self.c10 and self.c10 > self.c4)

        self.failUnless(self.c5 == self.c5)
        self.failUnless(self.c5 > self.c6 and self.c6 < self.c5)
        self.failUnless(self.c5 < self.c7 and self.c7 > self.c5)
        self.failUnless(self.c5 > self.c8 and self.c8 < self.c5)
        self.failUnless(self.c5 > self.c9 and self.c9 < self.c5)
        self.failUnless(self.c5 > self.c10 and self.c10 < self.c5)

        self.failUnless(self.c6 == self.c6)
        self.failUnless(self.c6 < self.c7 and self.c7 > self.c6)
        self.failUnless(self.c6 < self.c8 and self.c8 > self.c6)
        self.failUnless(self.c6 > self.c9 and self.c9 < self.c6)
        self.failUnless(self.c6 > self.c10 and self.c10 < self.c6)

        self.failUnless(self.c7 == self.c7)
        self.failUnless(self.c7 > self.c8 and self.c8 < self.c7)
        self.failUnless(self.c7 > self.c9 and self.c9 < self.c7)
        self.failUnless(self.c7 > self.c10 and self.c10 < self.c7)

        self.failUnless(self.c8 == self.c8)
        self.failUnless(self.c8 > self.c9 and self.c9 < self.c8)
        self.failUnless(self.c8 > self.c10 and self.c10 < self.c8)

        self.failUnless(self.c9 == self.c9)
        self.failUnless(self.c9 < self.c10 and self.c10 > self.c9)

        self.failUnless(self.c10 == self.c10)

        temp = circle.Circle(self.c1.center, self.c1.radius)
        self.failUnless(self.c1 == temp)

        temp = circle.Circle(self.c1.center, self.c1.radius + 0.001)
        self.failUnless(self.c1 > temp)

        temp = circle.Circle(self.c1.center, self.c1.radius - 0.001)
        self.failUnless(self.c1 < temp)

    def testPointMapping(self):
        p = self.c1.mapPoint(self.p1)
        self.failUnless(p is None)
        p = self.c1.mapPoint((5,0))
        self.failUnless(p == (5,0))
        p = self.c1.mapPoint((5.001,0))
        self.failUnless(p is None)
        p = self.c1.mapPoint((5.001,0),0.001)
        self.failUnless(p == (5,0))
        p = self.c1.mapPoint((4.999,0))
        self.failUnless(p is None)
        p = self.c1.mapPoint((4.999,0),0.001)
        self.failUnless(p == (5,0))

    def testArea(self):
        area = 25.0 * math.pi
        self.failUnless(absdiff(self.c1.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c2.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c3.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c4.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c5.area(),area) < 1e-10)
        area = 100.0 * math.pi 
        self.failUnless(absdiff(self.c6.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c7.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c8.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c9.area(),area) < 1e-10)
        self.failUnless(absdiff(self.c10.area(),area) < 1e-10)

    def testCircumference(self):
        c = 10.0 * math.pi
        self.failUnless(absdiff(self.c1.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c2.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c3.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c4.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c5.circumference(),c) < 1e-10)
        c = 20.0 * math.pi 
        self.failUnless(absdiff(self.c6.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c7.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c8.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c9.circumference(),c) < 1e-10)
        self.failUnless(absdiff(self.c10.circumference(),c) < 1e-10)

class CircleTreeTestCase(unittest.TestCase):
    def setUp(self):
        self.tree = circle.CircleTree()
        self.p1 = point.Point(0,0)
        self.p2 = point.Point(10,0)
        self.p3 = point.Point(0,10)
        self.p4 = point.Point(-10,0)
        self.p5 = point.Point(0,-10)
        self.c1 = circle.Circle(self.p1, 5)
        self.c2 = circle.Circle(self.p2, 5)
        self.c3 = circle.Circle(self.p3, 5)
        self.c4 = circle.Circle(self.p4, 5)
        self.c5 = circle.Circle(self.p5, 5)
        self.c6 = circle.Circle(self.p1, 10)
        self.c7 = circle.Circle(self.p2, 10)
        self.c8 = circle.Circle(self.p3, 10)
        self.c9 = circle.Circle(self.p4, 10)
        self.c10 = circle.Circle(self.p5, 10)

    def testStorage(self):
        self.tree.store(self.c1)
        self.failUnless(len(self.tree) == 1)
        self.failUnless(self.c1 in self.tree)
        self.tree.store(self.c2)
        self.failUnless(len(self.tree) == 2)
        self.failUnless(self.c2 in self.tree)
        self.tree.store(self.c3)
        self.failUnless(len(self.tree) == 3)
        self.failUnless(self.c3 in self.tree)
        self.tree.store(self.c4)
        self.failUnless(len(self.tree) == 4)
        self.failUnless(self.c4 in self.tree)
        self.tree.store(self.c5)
        self.failUnless(len(self.tree) == 5)
        self.failUnless(self.c5 in self.tree)
        self.tree.store(self.c6)
        self.failUnless(len(self.tree) == 6)
        self.failUnless(self.c6 in self.tree)
        self.tree.store(self.c7)
        self.failUnless(len(self.tree) == 7)
        self.failUnless(self.c7 in self.tree)
        self.tree.store(self.c8)
        self.failUnless(len(self.tree) == 8)
        self.failUnless(self.c8 in self.tree)
        self.tree.store(self.c9)
        self.failUnless(len(self.tree) == 9)
        self.failUnless(self.c9 in self.tree)
        self.tree.store(self.c10)
        self.failUnless(len(self.tree) == 10)
        self.failUnless(self.c10 in self.tree)

        seed = 100
        random.seed(seed)
        for i in xrange(1000):
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            cp = point.Point(x,y)
            r = 1.0 + (random.random() * 50)
            c = circle.Circle(cp, r)
            self.tree.store(c)
        self.validateTree()

        cp = point.Point(5,5)
        for i in xrange(1000):
            r = 1.0 + (random.random() * 50)
            c = circle.Circle(cp, r)
            self.tree.store(c)
        self.validateTree()
        
    def validateTree(self):
        for i in xrange(1, len(self.tree)):
            cp = self.tree[i-1]
            cpx, cpy = cp.getCenter().getCoords()
            cpr = cp.getRadius()
            ci = self.tree[i]
            cix, ciy = ci.getCenter().getCoords()
            cir = ci.getRadius()
            cp_xmin = cpx - cpr
            cp_ymin = cpy - cpr
            cp_xmax = cpx + cpr
            cp_ymax = cpy + cpr
            ci_xmin = cix - cir
            ci_ymin = ciy - cir
            ci_xmax = cix + cir
            ci_ymax = ciy + cir
            self.failUnless(cp_xmin <= ci_xmin)
            if abs(cp_xmin - ci_xmin) < 1e-10:
                self.failUnless(cp_ymin <= ci_ymin)
                if abs(cp_ymin - ci_ymin) < 1e-10:
                    self.failUnless(cp_xmax <= ci_xmax)                    
                    if abs(cp_xmax - ci_xmax) < 1e-10:
                        self.failUnless(cp_ymax <= ci_ymax)

    def testBinscan(self):
        self.tree.store(self.c1)
        self.tree.store(self.c2)
        self.tree.store(self.c3)
        self.tree.store(self.c4)
        self.tree.store(self.c5)
        self.tree.store(self.c6)
        self.tree.store(self.c7)
        self.tree.store(self.c8)
        self.tree.store(self.c9)
        self.tree.store(self.c10)
        sc = self.tree.binscan(self.c1)
        self.failUnless(sc is self.c1)
        sc = self.tree.binscan(self.c2)
        self.failUnless(sc is self.c2)
        sc = self.tree.binscan(self.c3)
        self.failUnless(sc is self.c3)
        sc = self.tree.binscan(self.c4)
        self.failUnless(sc is self.c4)
        sc = self.tree.binscan(self.c5)
        self.failUnless(sc is self.c5)
        sc = self.tree.binscan(self.c6)
        self.failUnless(sc is self.c6)
        sc = self.tree.binscan(self.c7)
        self.failUnless(sc is self.c7)
        sc = self.tree.binscan(self.c8)
        self.failUnless(sc is self.c8)
        sc = self.tree.binscan(self.c9)
        self.failUnless(sc is self.c9)
        sc = self.tree.binscan(self.c10)
        self.failUnless(sc is self.c10)

        temp = circle.Circle(self.c1.center, self.c1.radius)
        sc = self.tree.binscan(temp)
        self.failUnless(sc is self.c1)

    def testScan(self):
        self.tree.store(self.c1)
        self.tree.store(self.c2)
        self.tree.store(self.c3)
        self.tree.store(self.c4)
        self.tree.store(self.c5)
        self.tree.store(self.c6)
        self.tree.store(self.c7)
        self.tree.store(self.c8)
        self.tree.store(self.c9)
        self.tree.store(self.c10)
        sc = self.tree.scan(self.c1)
        self.failUnless(sc is self.c1)
        sc = self.tree.scan(self.c2)
        self.failUnless(sc is self.c2)
        sc = self.tree.scan(self.c3)
        self.failUnless(sc is self.c3)
        sc = self.tree.scan(self.c4)
        self.failUnless(sc is self.c4)
        sc = self.tree.scan(self.c5)
        self.failUnless(sc is self.c5)
        sc = self.tree.scan(self.c6)
        self.failUnless(sc is self.c6)
        sc = self.tree.scan(self.c7)
        self.failUnless(sc is self.c7)
        sc = self.tree.scan(self.c8)
        self.failUnless(sc is self.c8)
        sc = self.tree.scan(self.c9)
        self.failUnless(sc is self.c9)
        sc = self.tree.scan(self.c10)
        self.failUnless(sc is self.c10)

        temp = circle.Circle(self.c1.center, self.c1.radius)
        sc = self.tree.scan(temp)
        self.failUnless(sc is self.c1)

    def testRemove(self):
        self.tree.store(self.c1)
        self.tree.store(self.c2)
        self.tree.store(self.c3)
        self.tree.store(self.c4)
        self.tree.store(self.c5)
        self.tree.store(self.c6)
        self.tree.store(self.c7)
        self.tree.store(self.c8)
        self.tree.store(self.c9)
        self.tree.store(self.c10)
        self.tree.remove(self.c1)
        self.failUnless(len(self.tree) == 9)
        self.failIf(self.c1 in self.tree)
        self.tree.remove(self.c2)
        self.failUnless(len(self.tree) == 8)
        self.failIf(self.c2 in self.tree)
        self.tree.remove(self.c3)
        self.failUnless(len(self.tree) == 7)
        self.failIf(self.c3 in self.tree)
        self.tree.remove(self.c4)
        self.failUnless(len(self.tree) == 6)
        self.failIf(self.c4 in self.tree)
        self.tree.remove(self.c5)
        self.failUnless(len(self.tree) == 5)
        self.failIf(self.c5 in self.tree)
        self.tree.remove(self.c6)
        self.failUnless(len(self.tree) == 4)
        self.failIf(self.c6 in self.tree)
        self.tree.remove(self.c7)
        self.failUnless(len(self.tree) == 3)
        self.failIf(self.c7 in self.tree)
        self.tree.remove(self.c8)
        self.failUnless(len(self.tree) == 2)
        self.failIf(self.c8 in self.tree)
        self.tree.remove(self.c9)
        self.failUnless(len(self.tree) == 1)
        self.failIf(self.c9 in self.tree)
        self.tree.remove(self.c10)
        self.failIf(len(self.tree))
        self.failIf(self.c10 in self.tree)

    def testMapping(self):
        self.tree.store(self.c1)
        self.tree.store(self.c2)
        self.tree.store(self.c3)
        self.tree.store(self.c4)
        self.tree.store(self.c5)
        self.tree.store(self.c6)
        self.tree.store(self.c7)
        self.tree.store(self.c8)
        self.tree.store(self.c9)
        self.tree.store(self.c10)
        hits = self.tree.mapPoint((5,0))
        self.failUnless(len(hits) == 2)
        self.failUnless(hits[0][0] is self.c1 or hits[1][0] is self.c1)
        self.failUnless(hits[0][0] is self.c2 or hits[1][0] is self.c2)
        self.failUnless(hits[0][1] == (5,0))
        self.failUnless(hits[1][1] == (5,0))
        hits = self.tree.mapPoint((5.001,0))
        self.failIf(len(hits))
        hits = self.tree.mapPoint((5.001,0),0.001)
        self.failUnless(len(hits) == 2)
        self.failUnless(hits[0][0] is self.c1 or hits[1][0] is self.c1)
        self.failUnless(hits[0][0] is self.c2 or hits[1][0] is self.c2)
        self.failUnless(hits[0][1] == (5,0))
        self.failUnless(hits[1][1] == (5,0))
        hits = self.tree.mapPoint((4.999,0))
        self.failIf(len(hits))
        hits = self.tree.mapPoint((4.999,0),0.001)
        self.failUnless(len(hits) == 2)
        self.failUnless(hits[0][0] is self.c1 or hits[1][0] is self.c1)
        self.failUnless(hits[0][0] is self.c2 or hits[1][0] is self.c2)
        self.failUnless(hits[0][1] == (5,0))
        self.failUnless(hits[1][1] == (5,0))
        hits = self.tree.mapPoint((20,0))
        self.failUnless(len(hits) == 1)
        self.failUnless(hits[0][0] is self.c7)
        self.failUnless(hits[0][1] == (20,0))

if __name__ == "__main__":
    CircleTestSuite = unittest.TestSuite()
    CircleTestSuite.addTest(CircleTestCase("testCreation"))
    CircleTestSuite.addTest(CircleTestCase("testComparison"))
    CircleTestSuite.addTest(CircleTestCase("testPointMapping"))
    CircleTestSuite.addTest(CircleTestCase("testArea"))
    CircleTestSuite.addTest(CircleTestCase("testCircumference"))

    CircleTreeTestSuite = unittest.TestSuite()
    CircleTreeTestSuite.addTest(CircleTreeTestCase("testStorage"))
    CircleTreeTestSuite.addTest(CircleTreeTestCase("testBinscan"))
    CircleTreeTestSuite.addTest(CircleTreeTestCase("testScan"))
    CircleTreeTestSuite.addTest(CircleTreeTestCase("testRemove"))
    CircleTreeTestSuite.addTest(CircleTreeTestCase("testMapping"))
    unittest.main()
